/* XDRET.C   (c)1994, Anthony Hotchkiss  */

#include <stdio.h>
#include <string.h>
#include "adslib.h"
#include "adxlib.h"
/* XDATA selective retrieval example */
int xdret (void)
{
        char aname[133], xword[133];
struct resbuf *elist, *apid, *temp, *temp2;
        ads_name ename;
        ads_real last_real_value = 3.0;
        ads_point pt;
ads_getstring(0,"\nApplication name: ",aname);
if (ads_tblsearch("appid", aname, 0) == NULL) 
{
ads_alert("Application not registered");
 ads_retvoid();
                        return RTERROR;
                }
apid = ads_buildlist(RTSTR,aname,0); 
if(ads_entsel("\nSelect entity:",ename,pt) != RTNORM) 
{
ads_alert("No entity selected"); ads_relrb(apid);
                        ads_retvoid();
                        return RTERROR;
                }
        ads_redraw(ename, 3);
        elist = ads_entgetx(ename,apid);
        ads_relrb(apid);
        temp = elist;
temp = adx_assoc(1000,temp);
ads_getstring(0,"\nItem identifier: ",xword); 
while(strcmp(temp->resval.rstring,xword))
                {
                        temp = temp->rbnext;
                        if(temp->resval.rreal == last_real_value)
                                {
ads_alert("Item identifier not found"); 
ads_redraw(ename, 1); 
ads_relrb(elist); 
                                        ads_retvoid();
                                        return RTERROR;
                                }
                        temp = adx_assoc(1000,temp);
                }
        temp = temp->rbnext; 
        temp2 = temp->rbnext;
        temp->rbnext = NULL; 
        adx_printf_dxf(temp);
if((temp->restype >=1040) && (temp->restype <= 1042)) 
ads_printf("%0.3f\n",temp->resval.rreal);
        ads_redraw(ename, 1);
        ads_relrb(elist); 
        ads_relrb(temp2);
        ads_retvoid();
} /* xdret */
/*FUNCLOAD -- Define the external functions */
void funcload(void)
{
        ads_defun("C:XDRET", 1);
}
/*DOFUN -- Execute the external functions */
void dofun()
{
        xdret();
}
void main(int argc, char **argv)
{
ads_init(argc, argv);               /* Open communication with AutoLISP */
 for ( ;; ) 
                        {                                                        /* Request/Result loop */
                                switch(ads_link(RSRSLT)) 
                                {
case RQXLOAD:                             /* Load & define functions */
 funcload();
                                        break;
case RQSUBR:                   /* Handle external function requests */
 dofun();
                                break;
                                }
                } /* main */
